diff --git a/components/camel-saxon/pom.xml b/components/camel-saxon/pom.xml
index fee0b6c9da6..10a545b6b8c 100644
--- a/components/camel-saxon/pom.xml
+++ b/components/camel-saxon/pom.xml
@@ -29,6 +29,7 @@
     <artifactId>camel-saxon</artifactId>
     <packaging>jar</packaging>
     <name>Camel :: Saxon</name>
+    <version>4.4.0.redhat-00019-hf1</version>
     <description>Camel Saxon (XQuery/XPath) support</description>
 
     <properties>
@@ -41,6 +42,7 @@
         <dependency>
             <groupId>org.apache.camel</groupId>
             <artifactId>camel-xpath</artifactId>
+            <version>4.4.0.redhat-00019-hf1</version>
         </dependency>
         <dependency>
             <groupId>net.sf.saxon</groupId>
diff --git a/components/camel-saxon/src/generated/resources/META-INF/services/org/apache/camel/component.properties b/components/camel-saxon/src/generated/resources/META-INF/services/org/apache/camel/component.properties
index e1612696337..29dae80832e 100644
--- a/components/camel-saxon/src/generated/resources/META-INF/services/org/apache/camel/component.properties
+++ b/components/camel-saxon/src/generated/resources/META-INF/services/org/apache/camel/component.properties
@@ -2,6 +2,6 @@
 components=xquery
 groupId=org.apache.camel
 artifactId=camel-saxon
-version=4.4.0.redhat-00019
+version=4.4.0.redhat-00019-hf1
 projectName=Camel :: Saxon
 projectDescription=Camel Saxon (XQuery/XPath) support
diff --git a/components/camel-saxon/src/generated/resources/META-INF/services/org/apache/camel/language.properties b/components/camel-saxon/src/generated/resources/META-INF/services/org/apache/camel/language.properties
index dcab8f24c7b..bb18408ab8c 100644
--- a/components/camel-saxon/src/generated/resources/META-INF/services/org/apache/camel/language.properties
+++ b/components/camel-saxon/src/generated/resources/META-INF/services/org/apache/camel/language.properties
@@ -2,6 +2,6 @@
 languages=xquery
 groupId=org.apache.camel
 artifactId=camel-saxon
-version=4.4.0.redhat-00019
+version=4.4.0.redhat-00019-hf1
 projectName=Camel :: Saxon
 projectDescription=Camel Saxon (XQuery/XPath) support
diff --git a/components/camel-saxon/src/generated/resources/org/apache/camel/component/xquery/xquery.json b/components/camel-saxon/src/generated/resources/org/apache/camel/component/xquery/xquery.json
index e2a083922e1..f75d30e333e 100644
--- a/components/camel-saxon/src/generated/resources/org/apache/camel/component/xquery/xquery.json
+++ b/components/camel-saxon/src/generated/resources/org/apache/camel/component/xquery/xquery.json
@@ -11,7 +11,7 @@
     "supportLevel": "Stable",
     "groupId": "org.apache.camel",
     "artifactId": "camel-saxon",
-    "version": "4.4.0.redhat-00019",
+    "version": "4.4.0.redhat-00019-hf1",
     "scheme": "xquery",
     "extendsScheme": "",
     "syntax": "xquery:resourceUri",
diff --git a/components/camel-saxon/src/generated/resources/org/apache/camel/language/xquery/xquery.json b/components/camel-saxon/src/generated/resources/org/apache/camel/language/xquery/xquery.json
index 6c820ce6b69..b18a850134f 100644
--- a/components/camel-saxon/src/generated/resources/org/apache/camel/language/xquery/xquery.json
+++ b/components/camel-saxon/src/generated/resources/org/apache/camel/language/xquery/xquery.json
@@ -11,7 +11,7 @@
     "supportLevel": "Stable",
     "groupId": "org.apache.camel",
     "artifactId": "camel-saxon",
-    "version": "4.4.0.redhat-00019",
+    "version": "4.4.0.redhat-00019-hf1",
     "modelName": "xquery",
     "modelJavaType": "org.apache.camel.model.language.XQueryExpression"
   },
diff --git a/components/camel-xpath/pom.xml b/components/camel-xpath/pom.xml
index c99f3b1846d..08392ae641a 100644
--- a/components/camel-xpath/pom.xml
+++ b/components/camel-xpath/pom.xml
@@ -31,6 +31,7 @@
 
     <name>Camel :: XPath</name>
     <description>Camel XPath language</description>
+    <version>4.4.0.redhat-00019-hf1</version>
 
     <dependencies>
 
diff --git a/components/camel-xpath/src/generated/resources/META-INF/services/org/apache/camel/language.properties b/components/camel-xpath/src/generated/resources/META-INF/services/org/apache/camel/language.properties
index b29da6819d7..cc12d2244c4 100644
--- a/components/camel-xpath/src/generated/resources/META-INF/services/org/apache/camel/language.properties
+++ b/components/camel-xpath/src/generated/resources/META-INF/services/org/apache/camel/language.properties
@@ -2,6 +2,6 @@
 languages=xpath
 groupId=org.apache.camel
 artifactId=camel-xpath
-version=4.4.0.redhat-00019
+version=4.4.0.redhat-00019-hf1
 projectName=Camel :: XPath
 projectDescription=Camel XPath language
diff --git a/components/camel-xpath/src/generated/resources/org/apache/camel/language/xpath/xpath.json b/components/camel-xpath/src/generated/resources/org/apache/camel/language/xpath/xpath.json
index 18f7ebabb2f..627e2f0c25a 100644
--- a/components/camel-xpath/src/generated/resources/org/apache/camel/language/xpath/xpath.json
+++ b/components/camel-xpath/src/generated/resources/org/apache/camel/language/xpath/xpath.json
@@ -11,7 +11,7 @@
     "supportLevel": "Stable",
     "groupId": "org.apache.camel",
     "artifactId": "camel-xpath",
-    "version": "4.4.0.redhat-00019",
+    "version": "4.4.0.redhat-00019-hf1",
     "modelName": "xpath",
     "modelJavaType": "org.apache.camel.model.language.XPathExpression"
   },
diff --git a/components/camel-xpath/src/main/java/org/apache/camel/language/xpath/XPathLanguage.java b/components/camel-xpath/src/main/java/org/apache/camel/language/xpath/XPathLanguage.java
index 0bc94777575..ff34ea57260 100644
--- a/components/camel-xpath/src/main/java/org/apache/camel/language/xpath/XPathLanguage.java
+++ b/components/camel-xpath/src/main/java/org/apache/camel/language/xpath/XPathLanguage.java
@@ -130,11 +130,7 @@ public class XPathLanguage extends SingleInputTypedLanguageSupport implements Pr
     protected void configureBuilder(XPathBuilder builder, Object[] properties, Expression source) {
         builder.setSource(source);
 
-        Class<?> clazz = property(Class.class, properties, 0, null);
-        if (clazz != null) {
-            builder.setResultType(clazz);
-        }
-        clazz = property(Class.class, properties, 2, documentType);
+        Class<?> clazz = property(Class.class, properties, 2, documentType);
         if (clazz != null) {
             builder.setDocumentType(clazz);
         }
@@ -176,6 +172,11 @@ public class XPathLanguage extends SingleInputTypedLanguageSupport implements Pr
         if (ns != null && !ns.isEmpty()) {
             builder.setNamespaces(ns);
         }
+        // must set result type last as it influence the QName in use
+        clazz = property(Class.class, properties, 0, null);
+        if (clazz != null) {
+            builder.setResultType(clazz);
+        }
     }
 
     @Override
diff --git a/components/pom.xml b/components/pom.xml
index e83f65dd908..e5bffbc1e5b 100644
--- a/components/pom.xml
+++ b/components/pom.xml
@@ -359,6 +359,7 @@
             <plugin>
                 <groupId>org.apache.camel</groupId>
                 <artifactId>camel-package-maven-plugin</artifactId>
+                <version>4.4.0.redhat-00019</version>
                 <configuration>
                     <!-- set to true to make build fail fast if missing documentation in docs files -->
                     <failFast>false</failFast>
@@ -383,7 +384,7 @@
                     <dependency>
                         <groupId>org.apache.camel</groupId>
                         <artifactId>camel-core-model</artifactId>
-                        <version>${project.version}</version>
+                        <version>4.4.0.redhat-00019</version>
                         <scope>compile</scope>
                     </dependency>
                 </dependencies>
diff --git a/parent/pom.xml b/parent/pom.xml
index 2ed7ae94873..922e30005da 100644
--- a/parent/pom.xml
+++ b/parent/pom.xml
@@ -2085,6 +2085,12 @@
                 <artifactId>camel-sap-netweaver</artifactId>
                 <version>${camel-community.version}</version>
             </dependency>
+            <dependency>
+                <groupId>org.apache.camel</groupId>
+                <artifactId>camel-saxon</artifactId>
+                <version>${project.version}</version>
+                <type>jar</type>
+            </dependency>
             <dependency>
                 <groupId>org.apache.camel</groupId>
                 <artifactId>camel-saxon</artifactId>
@@ -2450,6 +2456,11 @@
                 <artifactId>camel-xmpp</artifactId>
                 <version>${camel-community.version}</version>
             </dependency>
+            <dependency>
+                <groupId>org.apache.camel</groupId>
+                <artifactId>camel-xpath</artifactId>
+                <version>${project.version}</version>
+            </dependency>
             <dependency>
                 <groupId>org.apache.camel</groupId>
                 <artifactId>camel-xpath</artifactId>