diff --git a/catalog/camel-catalog-provider-springboot/src/main/resources/org/apache/camel/springboot/catalog/components/xquery.json b/catalog/camel-catalog-provider-springboot/src/main/resources/org/apache/camel/springboot/catalog/components/xquery.json
index 9e02593c3e6..8f00f6c1d57 100644
--- a/catalog/camel-catalog-provider-springboot/src/main/resources/org/apache/camel/springboot/catalog/components/xquery.json
+++ b/catalog/camel-catalog-provider-springboot/src/main/resources/org/apache/camel/springboot/catalog/components/xquery.json
@@ -11,7 +11,7 @@
     "supportLevel": "Stable",
     "groupId": "org.apache.camel.springboot",
     "artifactId": "camel-saxon-starter",
-    "version": "4.4.0-SNAPSHOT",
+    "version": "4.4.0.redhat-00014-hf1",
     "scheme": "xquery",
     "extendsScheme": "",
     "syntax": "xquery:resourceUri",
diff --git a/catalog/camel-catalog-provider-springboot/src/main/resources/org/apache/camel/springboot/catalog/languages/xpath.json b/catalog/camel-catalog-provider-springboot/src/main/resources/org/apache/camel/springboot/catalog/languages/xpath.json
index 540ca0695cc..fb7142218a7 100644
--- a/catalog/camel-catalog-provider-springboot/src/main/resources/org/apache/camel/springboot/catalog/languages/xpath.json
+++ b/catalog/camel-catalog-provider-springboot/src/main/resources/org/apache/camel/springboot/catalog/languages/xpath.json
@@ -11,7 +11,7 @@
     "supportLevel": "Stable",
     "groupId": "org.apache.camel.springboot",
     "artifactId": "camel-xpath-starter",
-    "version": "4.4.0-SNAPSHOT",
+    "version": "4.4.0.redhat-00014-hf1",
     "modelName": "xpath",
     "modelJavaType": "org.apache.camel.model.language.XPathExpression"
   },
diff --git a/catalog/camel-catalog-provider-springboot/src/main/resources/org/apache/camel/springboot/catalog/languages/xquery.json b/catalog/camel-catalog-provider-springboot/src/main/resources/org/apache/camel/springboot/catalog/languages/xquery.json
index 3de49483de6..58839848881 100644
--- a/catalog/camel-catalog-provider-springboot/src/main/resources/org/apache/camel/springboot/catalog/languages/xquery.json
+++ b/catalog/camel-catalog-provider-springboot/src/main/resources/org/apache/camel/springboot/catalog/languages/xquery.json
@@ -11,7 +11,7 @@
     "supportLevel": "Stable",
     "groupId": "org.apache.camel.springboot",
     "artifactId": "camel-saxon-starter",
-    "version": "4.4.0-SNAPSHOT",
+    "version": "4.4.0.redhat-00014-hf1",
     "modelName": "xquery",
     "modelJavaType": "org.apache.camel.model.language.XQueryExpression"
   },
diff --git a/components-starter/camel-saxon-starter/pom.xml b/components-starter/camel-saxon-starter/pom.xml
index 48ade798feb..89937b80e06 100644
--- a/components-starter/camel-saxon-starter/pom.xml
+++ b/components-starter/camel-saxon-starter/pom.xml
@@ -27,6 +27,7 @@
   <artifactId>camel-saxon-starter</artifactId>
   <packaging>jar</packaging>
   <name>Camel SB Starters :: Saxon</name>
+  <version>4.4.0.redhat-00014-hf1</version>
   <description>Spring-Boot Starter for Camel Saxon (XQuery/XPath) support</description>
   <dependencies>
     <dependency>
@@ -37,7 +38,7 @@
     <dependency>
       <groupId>org.apache.camel</groupId>
       <artifactId>camel-saxon</artifactId>
-      <version>${camel-version}</version>
+      <version>4.4.0.redhat-00019-hf1</version>
     </dependency>
     <!--START OF GENERATED CODE-->
     <dependency>
diff --git a/components-starter/camel-xpath-starter/pom.xml b/components-starter/camel-xpath-starter/pom.xml
index 0f29f6d2bae..9b48af23bc9 100644
--- a/components-starter/camel-xpath-starter/pom.xml
+++ b/components-starter/camel-xpath-starter/pom.xml
@@ -27,6 +27,7 @@
   <artifactId>camel-xpath-starter</artifactId>
   <packaging>jar</packaging>
   <name>Camel SB Starters :: XPath</name>
+  <version>4.4.0.redhat-00014-hf1</version>
   <description>Spring-Boot Starter for Camel XPath language</description>
   <dependencies>
     <dependency>
@@ -37,7 +38,7 @@
     <dependency>
       <groupId>org.apache.camel</groupId>
       <artifactId>camel-xpath</artifactId>
-      <version>${camel-version}</version>
+      <version>4.4.0.redhat-00019-hf1</version>
     </dependency>
     <!--START OF GENERATED CODE-->
     <dependency>
diff --git a/maintenance/pom.xml b/maintenance/pom.xml
index 6d2a5643595..17aa19809b4 100644
--- a/maintenance/pom.xml
+++ b/maintenance/pom.xml
@@ -29,6 +29,7 @@
 
     <groupId>com.redhat.camel.springboot.platform</groupId>
     <artifactId>redhat-camel-spring-boot-maintenance</artifactId>
+    <version>4.4.0.redhat-00014-hf1</version>
     <packaging>pom</packaging>
     <name>Camel SB Maintenance</name>
 
@@ -38,8 +39,10 @@
     </modules>
 
     <properties>
-    <version.camel>4.4.0.redhat-00019</version.camel>
-    <version.camel-spring-boot>4.4.0.redhat-00014</version.camel-spring-boot>
+        <patch.camel-version>4.4.0.redhat-00019-hf1</patch.camel-version>
+        <patch.camel-spring-boot-version>4.4.0.redhat-00014-hf1</patch.camel-spring-boot-version>
+        <version.camel>4.4.0.redhat-00019</version.camel>
+        <version.camel-spring-boot>4.4.0.redhat-00014</version.camel-spring-boot>
   </properties>
 
 </project>
diff --git a/maintenance/redhat-camel-spring-boot-patch-metadata/pom.xml b/maintenance/redhat-camel-spring-boot-patch-metadata/pom.xml
index d2ac7eb7d55..13948faed86 100644
--- a/maintenance/redhat-camel-spring-boot-patch-metadata/pom.xml
+++ b/maintenance/redhat-camel-spring-boot-patch-metadata/pom.xml
@@ -23,7 +23,7 @@
     <parent>
         <groupId>com.redhat.camel.springboot.platform</groupId>
         <artifactId>redhat-camel-spring-boot-maintenance</artifactId>
-        <version>4.4.0.redhat-00014</version>
+        <version>4.4.0.redhat-00014-hf1</version>
     </parent>
 
     <artifactId>redhat-camel-spring-boot-patch-metadata</artifactId>
@@ -32,7 +32,8 @@
 
     <properties>
         <!-- A list of versions used to filter patch metadata.xml -->
-        <patch.camel-version>4.4.0</patch.camel-version>
+        <patch.camel-version>4.4.0.redhat-00019-hf1</patch.camel-version>
+        <patch.camel-spring-boot-version>4.4.0.redhat-00014-hf1</patch.camel-spring-boot-version>
         <version.camel>4.4.0.redhat-00019</version.camel>
         <version.camel-spring-boot>4.4.0.redhat-00014</version.camel-spring-boot>
     </properties>
diff --git a/maintenance/redhat-camel-spring-boot-patch-metadata/src/main/resources/metadata.xml b/maintenance/redhat-camel-spring-boot-patch-metadata/src/main/resources/metadata.xml
index 5f9756151d0..c2ef2b45b19 100644
--- a/maintenance/redhat-camel-spring-boot-patch-metadata/src/main/resources/metadata.xml
+++ b/maintenance/redhat-camel-spring-boot-patch-metadata/src/main/resources/metadata.xml
@@ -17,7 +17,7 @@
 
 -->
 <metadata xmlns="urn:redhat:patch-metadata:1">
-    <product-bom groupId="com.redhat.camel.springboot.platform" artifactId="camel-spring-boot-bom" versions="[3.18,3.19)" />
+    <product-bom groupId="com.redhat.camel.springboot.platform" artifactId="camel-spring-boot-bom" versions="[4.4,4.5)" />
     <cves>
         <!--cve id="CVE-2023-123456" description="A CVE"
              cve-link="https://cve.mitre.org/cgi-bin/cvename.cgi?name=2023-123456"
@@ -26,8 +26,11 @@
         </cve-->
     </cves>
     <fixes>
-        <!--fix id="HF0-1" description="Camel on Spring Boot 3.18 HF0 (example) - Camel Core fix">
-            <affects groupId="org.apache.camel" artifactId="camel-core" versions="[3.0,${patch.camel-version})" fix="${patch.camel-version}" />
-        </fix-->
+        <fix id="HF1" description="Camel on Spring Boot 4.4.0 HF1 - Fix XPath evaluation fails with result type integer">
+            <affects groupId="org.apache.camel" artifactId="camel-xpath" versions="[4.4,${patch.camel-version})" fix="${patch.camel-version}" />
+            <affects groupId="org.apache.camel" artifactId="camel-saxon" versions="[4.4,${patch.camel-version})" fix="${patch.camel-version}" />
+            <affects groupId="org.apache.camel.springboot" artifactId="camel-xpath-starter" versions="[4.4,${patch.camel-spring-boot-version})" fix="${patch.camel-spring-boot-version}" />
+            <affects groupId="org.apache.camel.springboot" artifactId="camel-saxon-starter" versions="[4.4,${patch.camel-spring-boot-version})" fix="${patch.camel-spring-boot-version}" />
+        </fix>
     </fixes>
 </metadata>
diff --git a/maintenance/redhat-camel-spring-boot-patch-repository/pom.xml b/maintenance/redhat-camel-spring-boot-patch-repository/pom.xml
index e3bc1ae32d2..dae71aff0a7 100644
--- a/maintenance/redhat-camel-spring-boot-patch-repository/pom.xml
+++ b/maintenance/redhat-camel-spring-boot-patch-repository/pom.xml
@@ -23,7 +23,7 @@
     <parent>
         <groupId>com.redhat.camel.springboot.platform</groupId>
         <artifactId>redhat-camel-spring-boot-maintenance</artifactId>
-        <version>4.4.0.redhat-00014</version>
+        <version>4.4.0.redhat-00014-hf1</version>
     </parent>
 
     <artifactId>redhat-camel-spring-boot-patch-repository</artifactId>
@@ -35,7 +35,8 @@
     </description>
 
     <properties>
-        <patch.camel-version>4.4.0.redhat-00019</patch.camel-version>
+        <patch.camel-version>4.4.0.redhat-00019-hf1</patch.camel-version>
+        <patch.camel-spring-boot-version>4.4.0.redhat-00014-hf1</patch.camel-spring-boot-version>
         <version.camel>4.4.0.redhat-00019</version.camel>
         <version.camel-spring-boot>4.4.0.redhat-00014</version.camel-spring-boot>
     </properties>
@@ -44,7 +45,7 @@
         <dependency>
             <groupId>com.redhat.camel.springboot.platform</groupId>
             <artifactId>redhat-camel-spring-boot-patch-metadata</artifactId>
-            <version>4.4.0.redhat-00014</version>
+            <version>4.4.0.redhat-00014-hf1</version>
             <type>xml</type>
         </dependency>
         <!--
@@ -53,9 +54,24 @@
         -->
         <dependency>
             <groupId>org.apache.camel</groupId>
-            <artifactId>camel-core</artifactId>
+            <artifactId>camel-xpath</artifactId>
             <version>${patch.camel-version}</version>
         </dependency>
+        <dependency>
+            <groupId>org.apache.camel</groupId>
+            <artifactId>camel-saxon</artifactId>
+            <version>${patch.camel-version}</version>
+        </dependency>
+        <dependency>
+            <groupId>org.apache.camel.springboot</groupId>
+            <artifactId>camel-xpath-starter</artifactId>
+            <version>${patch.camel-spring-boot-version}</version>
+        </dependency>
+        <dependency>
+            <groupId>org.apache.camel.springboot</groupId>
+            <artifactId>camel-saxon-starter</artifactId>
+            <version>${patch.camel-spring-boot-version}</version>
+        </dependency>
 <!--        <dependency>-->
 <!--            <groupId>io.netty</groupId>-->
 <!--            <artifactId>netty-buffer</artifactId>-->
diff --git a/maintenance/redhat-camel-spring-boot-patch-repository/src/main/descriptors/repository.xml b/maintenance/redhat-camel-spring-boot-patch-repository/src/main/descriptors/repository.xml
index fc304cfaa5d..5488cdcc711 100644
--- a/maintenance/redhat-camel-spring-boot-patch-repository/src/main/descriptors/repository.xml
+++ b/maintenance/redhat-camel-spring-boot-patch-repository/src/main/descriptors/repository.xml
@@ -41,6 +41,10 @@
             <directory>${project.build.directory}/patch-repository</directory>
             <includes>
                 <include>com/redhat/camel/springboot/**</include>
+                <include>org/apache/camel/springboot/camel-saxon-starter/**</include>
+                <include>org/apache/camel/springboot/camel-xpath-starter/**</include>
+                <include>org/apache/camel/camel-saxon/**</include>
+                <include>org/apache/camel/camel-xpath/**</include>
             </includes>
         </fileSet>
     </fileSets>