diff -Naur '--exclude=.git' eap1717722144/.galleon/provisioning.xml xp1717722144/.galleon/provisioning.xml
--- eap1717722144/.galleon/provisioning.xml	2024-06-07 03:04:12.452583067 +0200
+++ xp1717722144/.galleon/provisioning.xml	2024-06-07 03:02:52.999470224 +0200
@@ -1,7 +1,7 @@
 <?xml version="1.0" ?>
 
 <installation xmlns="urn:jboss:galleon:provisioning:3.0">
-    <feature-pack location="org.jboss.eap.xp:wildfly-galleon-pack::zip@maven">
+    <feature-pack location="org.jboss.eap.xp:wildfly-galleon-pack:zip">
         <packages>
             <include name="docs.examples.configs"/>
         </packages>
diff -Naur '--exclude=.git' eap1717722144/.galleon/systempaths.txt xp1717722144/.galleon/systempaths.txt
--- eap1717722144/.galleon/systempaths.txt	2024-06-07 03:04:12.453583068 +0200
+++ xp1717722144/.galleon/systempaths.txt	1970-01-01 01:00:00.000000000 +0100
@@ -1 +0,0 @@
-modules/system/layers/base
diff -Naur '--exclude=.git' eap1717722144/.installation/licenses/license_accepted.properties xp1717722144/.installation/licenses/license_accepted.properties
--- eap1717722144/.installation/licenses/license_accepted.properties	2024-06-07 03:04:12.605583284 +0200
+++ xp1717722144/.installation/licenses/license_accepted.properties	2024-06-07 03:02:54.970473023 +0200
@@ -1,8 +1,8 @@
 #Agreements accepted during installation
-#Fri Jun 07 03:04:06 CEST 2024
-license.1.timestamp=2024-06-07T03\:04\:06.195289
+#Fri Jun 07 03:02:54 CEST 2024
+license.1.timestamp=2024-06-07T03\:02\:54.968609
 license.1.name=xp
 license.0.name=JBoss EAP EULA
 license.1.file=xp.txt
 license.0.file=jboss-eap-eula.txt
-license.0.timestamp=2024-06-07T03\:03\:26.287737
+license.0.timestamp=2024-06-07T03\:02\:54.968609
diff -Naur '--exclude=.git' eap1717722144/.installation/licenses/xp.txt xp1717722144/.installation/licenses/xp.txt
--- eap1717722144/.installation/licenses/xp.txt	1970-01-01 01:00:00.000000000 +0100
+++ xp1717722144/.installation/licenses/xp.txt	2024-06-07 03:02:54.970473023 +0200
@@ -0,0 +1,3 @@
+JBoss Enterprise Application Platform expansion pack (JBoss EAP XP or EAP XP) is subject to its own separate support policy and life cycle for closer alignment with Eclipse MicroProfile specification release cadence. JBoss EAP server instances with the EAP XP setup will be covered in their entirety by the new EAP XP policy and life cycle.
+
+By setting up EAP XP, this server will be subject to the EAP XP support and life cycle policy. Please refer to the JBoss Enterprise Application Platform expansion pack Life Cycle page at https://access.redhat.com/support/policy/updates/jboss_eap_xp_notes for more details"
\ No newline at end of file
diff -Naur '--exclude=.git' eap1717722144/.installation/manifest_version.yaml xp1717722144/.installation/manifest_version.yaml
--- eap1717722144/.installation/manifest_version.yaml	2024-06-07 03:04:12.404582998 +0200
+++ xp1717722144/.installation/manifest_version.yaml	2024-06-07 03:02:54.775472746 +0200
@@ -4,8 +4,8 @@
 - groupId: "org.jboss.eap.channels"
   artifactId: "eap-xp-5.0"
   version: "1.0.0.GA-redhat-00005"
-  description: "This manifest provides the latest upgrades to provision EAP XP 5.0"
+  description: "Manifest for EAP XP 5.0"
 - groupId: "org.jboss.eap.channels"
   artifactId: "eap-8.0"
   version: "1.2.0.GA-redhat-00009"
-  description: "This manifest provides the latest upgrades to provision EAP 8.0"
+  description: "Manifest for EAP 8.0 Update 2"
diff -Naur '--exclude=.git' eap1717722144/.installation/provisioning_record.xml xp1717722144/.installation/provisioning_record.xml
--- eap1717722144/.installation/provisioning_record.xml	2024-06-07 03:04:12.577583244 +0200
+++ xp1717722144/.installation/provisioning_record.xml	2024-06-07 03:02:54.578472466 +0200
@@ -1,7 +1,7 @@
 <?xml version="1.0" ?>
 
 <installation xmlns="urn:jboss:galleon:provisioning:3.0">
-    <feature-pack location="org.jboss.eap.xp:wildfly-galleon-pack::zip@maven">
+    <feature-pack location="org.jboss.eap.xp:wildfly-galleon-pack:zip">
         <packages>
             <include name="docs.examples.configs"/>
         </packages>