diff -Naur '--exclude=.git' eap1717721405/.galleon/hashes/.installation/.cache/hashes xp1717721405/.galleon/hashes/.installation/.cache/hashes
--- eap1717721405/.galleon/hashes/.installation/.cache/hashes	2024-06-07 02:51:55.658533556 +0200
+++ xp1717721405/.galleon/hashes/.installation/.cache/hashes	2024-06-07 02:50:36.804420460 +0200
@@ -12,10 +12,10 @@
 2f55c2cc55f8d5d408dd52dde0212eaf430d0ba0
 wildfly-config-gen-6.4.8.Final-redhat-00001.jar
 b57da8e88145e0841ed7f0efcba88f34d15cf1d1
-eap-8.0-1.2.0.GA-redhat-00009-manifest.yaml
-825a1b54f9e61682faef3048fc76b8f08cdf2ef8
 eap-xp-5.0-1.0.0.GA-redhat-00005-manifest.yaml
 0fb4e4c49909cb1d2e530a027a449171eea19dba
+eap-8.0-1.2.0.GA-redhat-00009-manifest.yaml
+825a1b54f9e61682faef3048fc76b8f08cdf2ef8
 wildfly-galleon-plugins-6.4.8.Final-redhat-00001.jar
 90e8dc74e365425adf10776916d47633f762d595
 wildfly-ee-galleon-pack-8.0.3.GA-redhat-00001.zip
@@ -25,4 +25,4 @@
 prospero-wildfly-galleon-pack-1.1.11.Final-redhat-00003.zip
 7a5eb3590da7763e50a9dfe0233e370107283028
 artifacts.txt
-1cfe6098a5ad0b85ba46026f22406eb70b65d984
+57bedc052e68f06f073521e21a1bf487d09e1718
diff -Naur '--exclude=.git' eap1717721405/.galleon/provisioning.xml xp1717721405/.galleon/provisioning.xml
--- eap1717721405/.galleon/provisioning.xml	2024-06-07 02:51:55.531533374 +0200
+++ xp1717721405/.galleon/provisioning.xml	2024-06-07 02:50:34.455417091 +0200
@@ -1,7 +1,7 @@
 <?xml version="1.0" ?>
 
 <installation xmlns="urn:jboss:galleon:provisioning:3.0">
-    <feature-pack location="org.jboss.eap.xp:wildfly-galleon-pack::zip@maven">
+    <feature-pack location="org.jboss.eap.xp:wildfly-galleon-pack:zip">
         <packages>
             <include name="docs.examples.configs"/>
         </packages>
diff -Naur '--exclude=.git' eap1717721405/.galleon/systempaths.txt xp1717721405/.galleon/systempaths.txt
--- eap1717721405/.galleon/systempaths.txt	2024-06-07 02:51:55.533533377 +0200
+++ xp1717721405/.galleon/systempaths.txt	1970-01-01 01:00:00.000000000 +0100
@@ -1 +0,0 @@
-modules/system/layers/base
diff -Naur '--exclude=.git' eap1717721405/.installation/.cache/artifacts.txt xp1717721405/.installation/.cache/artifacts.txt
--- eap1717721405/.installation/.cache/artifacts.txt	2024-06-07 02:51:55.690533602 +0200
+++ xp1717721405/.installation/.cache/artifacts.txt	2024-06-07 02:50:36.746420376 +0200
@@ -749,8 +749,8 @@
 io.vertx:vertx-amqp-client:jar:4.4.8.redhat-00001::1dd887211c9f84e6f435b2329028db610a5dc9aa::modules/system/layers/microprofile/io/vertx/client/amqp/main/vertx-amqp-client-4.4.8.redhat-00001.jar
 org.fusesource.jansi:jansi:jar:1.18.0.redhat-00001::abc164b31eaa5ec20ab98c5bd1dd220025ca0752::modules/system/layers/base/org/fusesource/jansi/main/jansi-1.18.0.redhat-00001.jar
 org.infinispan:infinispan-hibernate-cache-commons:jar:14.0.24.Final-redhat-00001::4e155c036011c17fcd8648eac50bdc5a82adfeaa::modules/system/layers/base/org/infinispan/hibernate-cache/main/infinispan-hibernate-cache-commons-14.0.24.Final-redhat-00001.jar
-org.jboss.eap.channels:eap-8.0:yaml:manifest:1.2.0.GA-redhat-00009::825a1b54f9e61682faef3048fc76b8f08cdf2ef8::.installation/.cache/eap-8.0-1.2.0.GA-redhat-00009-manifest.yaml
 org.jboss.eap.channels:eap-xp-5.0:yaml:manifest:1.0.0.GA-redhat-00005::0fb4e4c49909cb1d2e530a027a449171eea19dba::.installation/.cache/eap-xp-5.0-1.0.0.GA-redhat-00005-manifest.yaml
+org.jboss.eap.channels:eap-8.0:yaml:manifest:1.2.0.GA-redhat-00009::825a1b54f9e61682faef3048fc76b8f08cdf2ef8::.installation/.cache/eap-8.0-1.2.0.GA-redhat-00009-manifest.yaml
 org.wildfly.galleon-plugins:wildfly-galleon-plugins:jar:6.4.8.Final-redhat-00001::90e8dc74e365425adf10776916d47633f762d595::.installation/.cache/wildfly-galleon-plugins-6.4.8.Final-redhat-00001.jar
 org.jboss.eap:wildfly-ee-galleon-pack:zip:8.0.3.GA-redhat-00001::5a5a20491c66f35886e663bf9e47a75c99d608f5::.installation/.cache/wildfly-ee-galleon-pack-8.0.3.GA-redhat-00001.zip
 org.jboss.eap.xp:wildfly-galleon-pack:zip:5.0.0.GA-redhat-00005::aeabc6daa279462c9b819c82c1c517e7b3b453df::.installation/.cache/wildfly-galleon-pack-5.0.0.GA-redhat-00005.zip
diff -Naur '--exclude=.git' eap1717721405/.installation/installer-channels.yaml xp1717721405/.installation/installer-channels.yaml
--- eap1717721405/.installation/installer-channels.yaml	2024-06-07 02:51:10.303468506 +0200
+++ xp1717721405/.installation/installer-channels.yaml	2024-06-07 02:50:36.339419792 +0200
@@ -1,22 +1,22 @@
 ---
 schemaVersion: "2.0.0"
-name: "eap-8.0"
+name: "eap-xp-5.0"
 repositories:
   - id: "temp-repo-0"
     url: "file:jboss-eap-8.0.2.GA-maven-repository/maven-repository/"
 manifest:
   maven:
     groupId: "org.jboss.eap.channels"
-    artifactId: "eap-8.0"
+    artifactId: "eap-xp-5.0"
 resolve-if-no-stream: "none"
 ---
 schemaVersion: "2.0.0"
-name: "eap-xp-5.0"
+name: "eap-8.0"
 repositories:
   - id: "temp-repo-0"
     url: "file:jboss-eap-8.0.2.GA-maven-repository/maven-repository/"
 manifest:
   maven:
     groupId: "org.jboss.eap.channels"
-    artifactId: "eap-xp-5.0"
+    artifactId: "eap-8.0"
 resolve-if-no-stream: "none"
diff -Naur '--exclude=.git' eap1717721405/.installation/licenses/license_accepted.properties xp1717721405/.installation/licenses/license_accepted.properties
--- eap1717721405/.installation/licenses/license_accepted.properties	2024-06-07 02:51:55.693533606 +0200
+++ xp1717721405/.installation/licenses/license_accepted.properties	2024-06-07 02:50:36.556420104 +0200
@@ -1,8 +1,8 @@
 #Agreements accepted during installation
-#Fri Jun 07 02:51:49 CEST 2024
-license.1.timestamp=2024-06-07T02\:51\:49.461815
+#Fri Jun 07 02:50:36 CEST 2024
+license.1.timestamp=2024-06-07T02\:50\:36.554216
 license.1.name=xp
 license.0.name=JBoss EAP EULA
 license.1.file=xp.txt
 license.0.file=jboss-eap-eula.txt
-license.0.timestamp=2024-06-07T02\:51\:08.001714
+license.0.timestamp=2024-06-07T02\:50\:36.554216
diff -Naur '--exclude=.git' eap1717721405/.installation/licenses/xp.txt xp1717721405/.installation/licenses/xp.txt
--- eap1717721405/.installation/licenses/xp.txt	1970-01-01 01:00:00.000000000 +0100
+++ xp1717721405/.installation/licenses/xp.txt	2024-06-07 02:50:36.556420104 +0200
@@ -0,0 +1,3 @@
+JBoss Enterprise Application Platform expansion pack (JBoss EAP XP or EAP XP) is subject to its own separate support policy and life cycle for closer alignment with Eclipse MicroProfile specification release cadence. JBoss EAP server instances with the EAP XP setup will be covered in their entirety by the new EAP XP policy and life cycle.
+
+By setting up EAP XP, this server will be subject to the EAP XP support and life cycle policy. Please refer to the JBoss Enterprise Application Platform expansion pack Life Cycle page at https://access.redhat.com/support/policy/updates/jboss_eap_xp_notes for more details"
\ No newline at end of file
diff -Naur '--exclude=.git' eap1717721405/.installation/manifest_version.yaml xp1717721405/.installation/manifest_version.yaml
--- eap1717721405/.installation/manifest_version.yaml	2024-06-07 02:51:55.485533308 +0200
+++ xp1717721405/.installation/manifest_version.yaml	2024-06-07 02:50:36.345419801 +0200
@@ -2,10 +2,10 @@
 schemaVersion: "1.0.0"
 maven:
 - groupId: "org.jboss.eap.channels"
-  artifactId: "eap-8.0"
-  version: "1.2.0.GA-redhat-00009"
-  description: "This manifest provides the latest upgrades to provision EAP 8.0"
-- groupId: "org.jboss.eap.channels"
   artifactId: "eap-xp-5.0"
   version: "1.0.0.GA-redhat-00005"
-  description: "This manifest provides the latest upgrades to provision EAP XP 5.0"
+  description: "Manifest for EAP XP 5.0"
+- groupId: "org.jboss.eap.channels"
+  artifactId: "eap-8.0"
+  version: "1.2.0.GA-redhat-00009"
+  description: "Manifest for EAP 8.0 Update 2"
diff -Naur '--exclude=.git' eap1717721405/.installation/provisioning_record.xml xp1717721405/.installation/provisioning_record.xml
--- eap1717721405/.installation/provisioning_record.xml	2024-06-07 02:51:55.658533556 +0200
+++ xp1717721405/.installation/provisioning_record.xml	2024-06-07 02:50:36.124419484 +0200
@@ -1,7 +1,7 @@
 <?xml version="1.0" ?>
 
 <installation xmlns="urn:jboss:galleon:provisioning:3.0">
-    <feature-pack location="org.jboss.eap.xp:wildfly-galleon-pack::zip@maven">
+    <feature-pack location="org.jboss.eap.xp:wildfly-galleon-pack:zip">
         <packages>
             <include name="docs.examples.configs"/>
         </packages>