diff --git a/src/components/clusters/ClusterDetailsMultiRegion/components/AddOns/AddOnsHelper.js b/src/components/clusters/ClusterDetailsMultiRegion/components/AddOns/AddOnsHelper.js
index 1657789ee..56bb6695f 100644
--- a/src/components/clusters/ClusterDetailsMultiRegion/components/AddOns/AddOnsHelper.js
+++ b/src/components/clusters/ClusterDetailsMultiRegion/components/AddOns/AddOnsHelper.js
@@ -143,6 +143,7 @@ const hasQuota = (addOn, cluster, organization, quotaList) => {
     return false;
   }
   const minCount = minQuotaCount(addOn);
+  console.log('DEBUG MR AddOnsHelper. hasQuota');
   const available = availableQuota(quotaList, {
     ...queryFromCluster(cluster),
     resourceType: QuotaTypes.ADD_ON,
@@ -177,7 +178,9 @@ const quotaCostOptions = (resourceName, cluster, quotaList, allOptions, currentV
     // names to work and avoid an empty options list.
     return allOptions;
   }
+  console.log('DEBUG Archived AddOnsHelper. quotaCostsOptions');
   const available = availableQuota(quotaList, query);
+
   return allOptions.filter((option) => available + currentValue >= option.value);
 };
 
diff --git a/src/components/clusters/ClusterDetails_archived_do_not_use/components/AddOns/AddOnsHelper.js b/src/components/clusters/ClusterDetails_archived_do_not_use/components/AddOns/AddOnsHelper.js
index 91811dab9..e2a50e37c 100644
--- a/src/components/clusters/ClusterDetails_archived_do_not_use/components/AddOns/AddOnsHelper.js
+++ b/src/components/clusters/ClusterDetails_archived_do_not_use/components/AddOns/AddOnsHelper.js
@@ -143,6 +143,7 @@ const hasQuota = (addOn, cluster, organization, quotaList) => {
     return false;
   }
   const minCount = minQuotaCount(addOn);
+  console.log('>> >> DEBUG Archived AddOnsHelper. hasQuota');
   const available = availableQuota(quotaList, {
     ...queryFromCluster(cluster),
     resourceType: QuotaTypes.ADD_ON,
@@ -150,6 +151,7 @@ const hasQuota = (addOn, cluster, organization, quotaList) => {
     // the billing_model field for addon's is addon specific and should not be a filter criteria against the cluster
     billingModel: RelatedResource.billing_model.ANY,
   });
+
   return available >= minCount;
 };
 
@@ -177,7 +179,9 @@ const quotaCostOptions = (resourceName, cluster, quotaList, allOptions, currentV
     // names to work and avoid an empty options list.
     return allOptions;
   }
+  console.log('>> >> DEBUG Archived AddOnsHelper. quotaCostsOptions');
   const available = availableQuota(quotaList, query);
+
   return allOptions.filter((option) => available + currentValue >= option.value);
 };
 
diff --git a/src/components/clusters/common/LoadBalancersDropdown/LoadBalancersDropdown.tsx b/src/components/clusters/common/LoadBalancersDropdown/LoadBalancersDropdown.tsx
index aa0fac292..874609f34 100644
--- a/src/components/clusters/common/LoadBalancersDropdown/LoadBalancersDropdown.tsx
+++ b/src/components/clusters/common/LoadBalancersDropdown/LoadBalancersDropdown.tsx
@@ -65,6 +65,7 @@ const LoadBalancersDropdown = ({
       isMultiAZ,
     };
     // @ts-ignore
+    console.log('>> >> DEBUG LoadBalancersDropDown');
     const quota = availableQuota(quotaList, query);
 
     const filteredValues = filterLoadBalancerValuesByQuota(currentValue, loadBalancerValues, quota);
diff --git a/src/components/clusters/common/PersistentStorageDropdown/PersistentStorageDropdown.tsx b/src/components/clusters/common/PersistentStorageDropdown/PersistentStorageDropdown.tsx
index 3cd28e08e..f679ed2a4 100644
--- a/src/components/clusters/common/PersistentStorageDropdown/PersistentStorageDropdown.tsx
+++ b/src/components/clusters/common/PersistentStorageDropdown/PersistentStorageDropdown.tsx
@@ -72,6 +72,7 @@ const PersistentStorageDropdown = ({
   };
 
   if (persistentStorageIsFetched && !persistentStorageIsError && quotaFetched && !quotaIsError) {
+    console.log('>> >> DEBUG PersistentStorageDropDown');
     const storageQuota = availableQuota(quotaList, {
       resourceType: QuotaTypes.STORAGE,
       billingModel,
diff --git a/src/components/clusters/common/archived_do_not_use/LoadBalancersDropdown/LoadBalancersDropdown.jsx b/src/components/clusters/common/archived_do_not_use/LoadBalancersDropdown/LoadBalancersDropdown.jsx
index bcd0cb504..c59f209c2 100644
--- a/src/components/clusters/common/archived_do_not_use/LoadBalancersDropdown/LoadBalancersDropdown.jsx
+++ b/src/components/clusters/common/archived_do_not_use/LoadBalancersDropdown/LoadBalancersDropdown.jsx
@@ -50,6 +50,7 @@ class LoadBalancersDropdown extends React.Component {
         isBYOC,
         isMultiAZ,
       };
+      console.log('>> >> DEBUG LoadBalancersDropDown. Archived');
       const quota = availableQuota(quotaList, query);
       const filteredValues = filterLoadBalancerValuesByQuota(
         currentValue,
diff --git a/src/components/clusters/common/archived_do_not_use/PersistentStorageDropdown/PersistentStorageDropdown.jsx b/src/components/clusters/common/archived_do_not_use/PersistentStorageDropdown/PersistentStorageDropdown.jsx
index 533c1d808..70aaaf23b 100644
--- a/src/components/clusters/common/archived_do_not_use/PersistentStorageDropdown/PersistentStorageDropdown.jsx
+++ b/src/components/clusters/common/archived_do_not_use/PersistentStorageDropdown/PersistentStorageDropdown.jsx
@@ -61,6 +61,7 @@ class PersistentStorageDropdown extends React.Component {
     };
 
     if (persistentStorageValues.fulfilled) {
+      console.log('>> >> DEBUG PersistentStorageDropDown. Archived');
       const storageQuota = availableQuota(quotaList, {
         resourceType: QuotaTypes.STORAGE,
         billingModel,
diff --git a/src/components/clusters/common/quotaSelectors.ts b/src/components/clusters/common/quotaSelectors.ts
index 9402eb62c..c6d54e47f 100644
--- a/src/components/clusters/common/quotaSelectors.ts
+++ b/src/components/clusters/common/quotaSelectors.ts
@@ -98,6 +98,7 @@ const queryFromQuotaParams = (quotaParams: QuotaParams): QuotaQuery => ({
  */
 const availableQuota = (quotaList: QuotaCostList | undefined, quotaParams: QuotaParams): number => {
   if (!quotaList) {
+    console.log('>> >> >> DEBUG availableQuota.!quotaList. Return 0', JSON.stringify(quotaParams));
     return 0;
   }
 
@@ -111,10 +112,16 @@ const availableQuota = (quotaList: QuotaCostList | undefined, quotaParams: Quota
   };
 
   const query = queryFromQuotaParams(queryParams);
-  return (quotaList?.items || []).reduce(
+  const result = (quotaList?.items || []).reduce(
     (acc, curr) => acc + availableFromQuotaCostItem(curr, query),
     0,
   );
+  console.log(
+    `>> >> >> DEBUG availableQuota.!quotaList. Return ${result}`,
+    JSON.stringify(quotaParams),
+  );
+
+  return result;
 };
 
 /**
@@ -198,16 +205,26 @@ const queryFromCluster = <E extends ClusterFromSubscription>(cluster: E): QuotaP
 const availableClustersFromQuota = (
   quotaList: QuotaCostList | undefined,
   quotaParams: QuotaParams,
-) => availableQuota(quotaList, { ...quotaParams, resourceType: QuotaTypes.CLUSTER });
+) => {
+  console.log('>> >> DEBUG quotaSelectors.availableClustersFromQuota');
+  return availableQuota(quotaList, { ...quotaParams, resourceType: QuotaTypes.CLUSTER });
+};
 
-const hasManagedQuotaSelector = (quotaList: QuotaCostList, product: string): boolean =>
-  availableClustersFromQuota(quotaList, { product }) >= 1;
+const hasManagedQuotaSelector = (quotaList: QuotaCostList, product: string): boolean => {
+  console.log('>> DEBUG quotaSelectors.hasManagedQuotaSelector');
+  const result = availableClustersFromQuota(quotaList, { product }) >= 1;
+  return result;
+};
 
-const hasHostedQuotaSelector = (quotaList?: QuotaCostList): boolean =>
-  availableClustersFromQuota(quotaList, {
-    product: normalizedProducts.ROSA,
-    billingModel: RelatedResource.billing_model.MARKETPLACE,
-  }) >= 1;
+const hasHostedQuotaSelector = (quotaList?: QuotaCostList): boolean => {
+  console.log('>> DEBUG quotaSelectors.hasHostedQuotaSelector');
+  const result =
+    availableClustersFromQuota(quotaList, {
+      product: normalizedProducts.ROSA,
+      billingModel: RelatedResource.billing_model.MARKETPLACE,
+    }) >= 1;
+  return result;
+};
 
 /**
  * Returns number of nodes of specific type that can be created/added, from 0 to `Infinity`.
@@ -215,8 +232,13 @@ const hasHostedQuotaSelector = (quotaList?: QuotaCostList): boolean =>
  * @param quotaList - `state.userProfile.organization.quotaList`
  * @param quotaParams - {product, cloudProviderID, resourceName, isBYOC,isMultiAz, billingModel}
  */
-const availableNodesFromQuota = (quotaList: QuotaCostList | undefined, quotaParams: QuotaParams) =>
-  availableQuota(quotaList, { ...quotaParams, resourceType: QuotaTypes.NODE });
+const availableNodesFromQuota = (
+  quotaList: QuotaCostList | undefined,
+  quotaParams: QuotaParams,
+) => {
+  console.log('>> >> DEBUG availableNodesFromQuota');
+  return availableQuota(quotaList, { ...quotaParams, resourceType: QuotaTypes.NODE });
+};
 
 const getAwsBillingAccountsFromQuota = (items?: QuotaCost[]) =>
   items
diff --git a/src/components/clusters/wizards/common/utils/quotas.ts b/src/components/clusters/wizards/common/utils/quotas.ts
index be52b98f2..d5274427a 100644
--- a/src/components/clusters/wizards/common/utils/quotas.ts
+++ b/src/components/clusters/wizards/common/utils/quotas.ts
@@ -18,8 +18,14 @@ export enum QuotaType {
   MultiAzResources = 'multiAzResources',
 }
 
-export const hasAvailableQuota = (quotaList: QuotaCostList | undefined, quotaParams: QuotaParams) =>
-  !!quotaList && availableQuota(quotaList, quotaParams) > 0;
+export const hasAvailableQuota = (
+  quotaList: QuotaCostList | undefined,
+  quotaParams: QuotaParams,
+) => {
+  console.log('>> >> DEBUG hasAvailableQuota');
+  const result = !!quotaList && availableQuota(quotaList, quotaParams) > 0;
+  return result;
+};
 
 export const quotaParams = {
   [QuotaType.OsdTrial]: {
diff --git a/src/components/clusters/wizards/osd/CreateOsdWizard.tsx b/src/components/clusters/wizards/osd/CreateOsdWizard.tsx
index 00536323b..1549f7807 100644
--- a/src/components/clusters/wizards/osd/CreateOsdWizard.tsx
+++ b/src/components/clusters/wizards/osd/CreateOsdWizard.tsx
@@ -88,6 +88,7 @@ const CreateOsdWizardInternal = () => {
   const persistentStorageValues = useGlobalState((state) => state.persistentStorageValues);
   const createClusterResponse = useGlobalState((state) => state.clusters.createdCluster);
 
+  console.log('DEBUG CreateOdWizard');
   const hasProductQuota =
     availableClustersFromQuota(organization.quotaList as QuotaCostList, {
       product,
diff --git a/src/components/clusters/wizards/rosa/ClusterSettings/Details/Details.tsx b/src/components/clusters/wizards/rosa/ClusterSettings/Details/Details.tsx
index bddaa00e7..fef6d263c 100644
--- a/src/components/clusters/wizards/rosa/ClusterSettings/Details/Details.tsx
+++ b/src/components/clusters/wizards/rosa/ClusterSettings/Details/Details.tsx
@@ -289,6 +289,8 @@ function Details() {
     };
     // TODO: OCMUI-943: CCS requires quota for both cluster and node.
     //   But how many nodes does ROSA require at creation time?
+
+    console.log('>> >> DEBUG Details');
     const clusterQuota = availableQuota(quotaList as QuotaCostList, {
       ...params,
       resourceType: QuotaTypes.CLUSTER,